﻿define surrond_y_first = [
    [(-1,-1), (-1, 0),(-1,1)],
    [(0,-1), (0, 0),(0,1)],
    [(1,-1), (1, 0),(1,1)],
]

init python:
    class find_pattern_animal:
        def __init__(self, name):
            self.name = name

    class find_pattern_class:
        def __init__(self, animals):
            self.animals = animals
            self.board = []
            self.make_board()

            self.position = None
            self.pattern = None
            self.selection = [1,1]

            self.stage = "start"
            self.time = 0

        def tick(self):
            self.time += .1

        def restart(self):
            self.stage = "clearing"
            self.time = 0
            self.board = []
            self.pattern = []
            renpy.play("find pattern/shuffle.ogg", "sound")

        def start(self):
            self.stage = "searching"
            self.time = 0
            self.choose()
            
        def clear(self):
            self.make_board()
            self.stage = "building"
        def go(self):
            self.choose()
            self.stage = "searching"

        def make_board(self):
            board = []
            for y in range(8):
                row = []
                for x in range(8):
                    row.append([random.choice(self.animals), random.choice([-1,1])])
                board.append(row)
            self.board = board
        def choose(self):
            x_center = random.randint(1,6)
            y_center = random.randint(1,6)
            self.position = [x_center,y_center]
            pattern = self.create_pattern()
            for y in range(0,3):
                for x in range(0,3):
                    if pattern[y][x]:
                        pattern[y][x] = self.board[y + y_center-1][x + x_center-1] 
            self.pattern = pattern

        def create_pattern(self, filled = 4):
            pattern = [0,0,0,0,0,0,0,0,0]
            while filled > 0:
                index = random.randint(0,8)
                if pattern[index] == 0:
                    pattern[index] = 1
                    filled -= 1
            return [pattern[i: i+3] for i in range(0, len(pattern), 3)]

        def clicked(self, y, x):
            pass
        def check(self):
            if self.selection[0] == self.position[0]-1 and self.selection[1] == self.position[1]-1:
                renpy.notify("success")
                self.stage = "found"
                renpy.play("find pattern/success.ogg", "sound")
            else:
                renpy.play("find pattern/wrong.ogg", "sound")

        def hovered(self, y, x):
            if 0 < y < 7:
                self.selection[1] = y-1
            if 0 < x < 7:
                self.selection[0] = x-1


        def move(self, direction):
            renpy.play("find pattern/move.ogg", "sound")
            if direction == "w":
                self.selection[1] -= 1
                if self.selection[1] < 0:
                    self.selection[1] = 0

            elif direction == "a":
                self.selection[0] -= 1
                if self.selection[0] < 0:
                    self.selection[0] = 0

            elif direction == "s":
                self.selection[1] += 1
                if self.selection[1] > 5:
                    self.selection[1] = 5

            elif direction == "d":
                self.selection[0] += 1
                if self.selection[0] > 5:
                    self.selection[0] = 5


transform find_pattern_animation():
    zoom .01
    pause random.random()+.1
    ease .2 zoom 1

screen find_pattern_screen():
    default g = find_pattern_class(all_animals)
    style_prefix "find"
    # vbox:
    #     button:
    #         text "Choose"
    #         action Function(g.choose)

    frame:
        fixed fit_first True:
            at zoom(3, True)
            vbox:
                for y,j in enumerate(g.board):
                    hbox:
                        for x,i in enumerate(j):
                            button:
                                padding 0,0 background None
                                at find_pattern_animation
                                add i[0] at flip(i[1])
                                action Function(g.check)
                                hovered Function(g.hovered, y, x)
            frame:
                background Frame("find_frame",6,6) anchor .0,.0
                xysize 96,96 pos g.selection[0]*32,g.selection[1]*32 padding 0,0

    if g.pattern:
        frame align .08,.2:
            vbox:
                at zoom(3, True)
                for y,j in enumerate(g.pattern):
                    hbox:
                        for x,i in enumerate(j):
                            if i:
                                button:
                                    padding 0,0 background None
                                    at find_pattern_animation
                                    add i[0] at flip(i[1])
                                    action Function(g.clicked, y, x)
                            else:
                                frame:
                                    at find_pattern_animation
                                    xysize 32,32 background None

    if g.stage in ["found", "searching"]:
        frame align .92,.2:
            xysize 288+20, 288+20
            text "{}".format(round(g.time,1))
    if g.stage == "start":
        frame:
            vbox:
                spacing 20
                text "Ready to find the pattern in the board?"
                button:
                    text "Let's go!"
                    action Function(g.start)
    elif g.stage == "searching":
        timer .1 repeat True action Function(g.tick)
    elif g.stage == "clearing":
        timer .2 action Function(g.clear)
    elif g.stage == "building":
        timer 1 action Function(g.go)
    elif g.stage == "found":
        frame:
            vbox:
                spacing 20
                text "Try another round?"
                hbox:
                    spacing 20
                    button:
                        text "Sure"
                        action Function(g.restart)
                    button:
                        text "Nah this is silly."
                        action Return(g.time)

    button xysize 300,100:
        align 1.0,1.0 offset -50,-150
        text "Check"
        action Function(g.check) keysym ["K_SPACE", "K_RETURN"]

    fixed xysize 100,100 align 0.0,1.0 offset 150,-150:
        button xysize 100,100:
            yoffset -100
            text "Up"
            action Function(g.move, "w") keysym ["K_UP", "w"]
        button xysize 100,100:
            xoffset -100
            text "Left"
            action Function(g.move, "a") keysym ["K_LEFT", "a"]
        button xysize 100,100:
            yoffset 100
            text "Down"
            action Function(g.move, "s") keysym ["K_DOWN", "s"]
        button xysize 100,100:
            xoffset 100
            text "Right"
            action Function(g.move, "d") keysym ["K_RIGHT", "d"]


style find_button:
    align (.5,.5) background "#280f44d8" padding (20,20)
style find_frame:
    align (.5,.5) background "#280f44d8" padding (20,20)
style find_text:
    align (.5,.5)


init:
    image find_frame = Crop((112,112,16,16), "find pattern/sprites.png")

    image find_animal_1 = Crop((0,0,32,32), "find pattern/sprites.png")
    image find_animal_2 = Crop((32,0,32,32), "find pattern/sprites.png")
    image find_animal_3 = Crop((64,0,32,32), "find pattern/sprites.png")
    image find_animal_4 = Crop((96,0,32,32), "find pattern/sprites.png")

    image find_animal_5 = Crop((0,32,32,32), "find pattern/sprites.png")
    image find_animal_6 = Crop((32,32,32,32), "find pattern/sprites.png")
    image find_animal_7 = Crop((64,32,32,32), "find pattern/sprites.png")
    image find_animal_8 = Crop((96,32,32,32), "find pattern/sprites.png")

    default all_animals = [
        "find_animal_1", "find_animal_2", "find_animal_3", "find_animal_4", 
        "find_animal_5",
    ]


label find_pattern_example:
    call screen find_pattern_screen

